﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=StaticCode
Version=7.8
@EndOfDesignText@
'Code module
'Subs in this code module will be accessible from all modules.
Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
	
End Sub

'Get the names of the TTSs
'Uses TTS Lib, Reflection Lib, Phone Lib
Sub GetTTSNamesAndPackages(t As TTS) As List
	Dim r As Reflector
	Dim pm As PackageManager
	Dim l As List
	l.Initialize
	r.Target = t
	Dim engines As List = r.RunMethod("getEngines")
	For Each o As Object In engines
		Dim m As Map
		m.Initialize
		r.Target = o
		m.Put("TTSPackage", r.GetField("name"))
		m.Put("TTSName", pm.GetApplicationLabel(r.GetField("name")))
		Dim sBool As String
		If r.GetField("name") = GetDefaultEngine(t) Then sBool = "true" Else sBool = "false"
		m.Put("IsDefaultTTS", sBool)
		l.Add(m)
	Next
	Return l
End Sub


'TTS set engine by packagename
'Uses Reflection Lib, TTS Lib
'Returns -1 if there was an error or 0 if everything is ok
Sub SetEngineByPackage(sPackage As String, t As TTS) As TTS
	Dim ph As Phone
	Dim r As Reflector
	If ph.SdkVersion < 14 Then
		r.Target = t
		Log("Setting Engine " & sPackage & " as default.")
		r.RunMethod2("setEngineByPackageName", sPackage, "java.lang.String")
		Return t
	Else
		Dim ttsNew As JavaObject
		ttsNew.InitializeNewInstance(Application.PackageName & ".ttsfunctions.GetNewTTS", Null)		
		Return ttsNew.RunMethod("ttsN", Array(r.GetContext, sPackage))
	End If
End Sub


#IF JAVA
import android.speech.tts.TextToSpeech;
import android.speech.tts.TextToSpeech.OnInitListener;

public static class GetNewTTS {

public void Initialize()  {
};

public TextToSpeech ttsN(android.content.Context cnt, String engine) {
		TextToSpeech tts;
	
		tts = new TextToSpeech(cnt, new OnInitListener(){

			@Override
			public void onInit(int i) {

			}}, engine);
		return tts;
};
};
#End If


'TTS check if it is speaking
'Uses JavaObject Lib, TTS Lib
Sub IsTTSSpeaking(t As TTS) As Boolean
	Dim jTTS As JavaObject = t 
	Return jTTS.RunMethod("isSpeaking", Null) 
End Sub

'Get Default Engine of TTS
'Uses JavaObject Lib, TTS Lib
Sub GetDefaultEngine(t As TTS) As String
	Dim jTTS As JavaObject = t
	Return jTTS.RunMethod("getDefaultEngine", Null)
End Sub

'TTS get max input length
'Uses JavaObject Lib, TTS Lib
Sub GetMaxInputLength(t As TTS) As Long
	Dim jTTS As JavaObject = t
	Return jTTS.RunMethod("getMaxSpeechInputLength", Null)
End Sub


'TTS synthesize to file
'Uses JavaObject Lib, TTS Lib, RuntimePermissions Lib
Sub SynthesizeToFile(t As TTS, subFolderToPutTheFile As String, filename As String, textToSpeak As String)
	Dim rp As RuntimePermissions
	Dim jo As JavaObject = t
	Dim m As JavaObject
	m.InitializeNewInstance("java.util.HashMap", Null)
	jo.RunMethod("synthesizeToFile", Array(textToSpeak, m, File.Combine(rp.GetSafeDirDefaultExternal(subFolderToPutTheFile), filename)))
End Sub


'Play synthesized File From TTS
'Uses RuntimePermissions Lib
Sub PlaySynthesizedFile(subFolderWhereTheFileIsLocated As String, fileName As String)
	Dim mp As MediaPlayer
	Dim rp As RuntimePermissions
	mp.Initialize
	mp.Load(rp.GetSafeDirDefaultExternal(subFolderWhereTheFileIsLocated), fileName)
	mp.Play
End Sub

